; ##############################################################################
; ##############################################################################
; ##############################################################################
; INITIALISIERUNG																
;																				
OW_INITIALISIERUNG:
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	cbi (OW_PORT),(OW_PIN_NR)	; PULL-UP aus	
	;  1-WIRE-ROM-ID					
	ldi temp1,ROM_ID_BYTE0		; FAM	
	ldi temp2,ROM_ID_BYTE1
	ldi temp3,ROM_ID_BYTE2
	ldi temp4,ROM_ID_BYTE3
	ldi temp5,ROM_ID_BYTE4
	ldi temp6,ROM_ID_BYTE5
	ldi temp7,ROM_ID_BYTE6
	ldi temp8,ROM_ID_BYTE7		; CRC	
	STS(adr_OW_ROM_ID_BEREICH8+0),temp1
	STS(adr_OW_ROM_ID_BEREICH8+1),temp2
	STS(adr_OW_ROM_ID_BEREICH8+2),temp3
	STS(adr_OW_ROM_ID_BEREICH8+3),temp4
	STS(adr_OW_ROM_ID_BEREICH8+4),temp5
	STS(adr_OW_ROM_ID_BEREICH8+5),temp6
	STS(adr_OW_ROM_ID_BEREICH8+6),temp7
	STS(adr_OW_ROM_ID_BEREICH8+7),temp8
	rcall ONE_WIRE_ROM_CRC7		; wichtig !
	; SCRATCHPAD						
	ldi temp1,SCRATCHPAD_BYTE0
	ldi temp2,SCRATCHPAD_BYTE1
	ldi temp3,SCRATCHPAD_BYTE2
	ldi temp4,SCRATCHPAD_BYTE3
	ldi temp5,SCRATCHPAD_BYTE4
	ldi temp6,SCRATCHPAD_BYTE5
	ldi temp7,SCRATCHPAD_BYTE6
	ldi temp8,SCRATCHPAD_BYTE7
	ldi temp9,SCRATCHPAD_BYTE8	; CRC
	STS(adr_OW_SCRATCHPAD_BEREICH9+0),temp1
	STS(adr_OW_SCRATCHPAD_BEREICH9+1),temp2
	STS(adr_OW_SCRATCHPAD_BEREICH9+2),temp3
	STS(adr_OW_SCRATCHPAD_BEREICH9+3),temp4
	STS(adr_OW_SCRATCHPAD_BEREICH9+4),temp5
	STS(adr_OW_SCRATCHPAD_BEREICH9+5),temp6
	STS(adr_OW_SCRATCHPAD_BEREICH9+6),temp7
	STS(adr_OW_SCRATCHPAD_BEREICH9+7),temp8
	STS(adr_OW_SCRATCHPAD_BEREICH9+8),temp9
	; CRC Check								
	rcall SCRATCHPAD_CRC8		; wichtig !
	; sperren								
	STS(adr_OW_ROM_COMAND),VOLL	; sperren	
	STS(adr_OW_FUNC_COMAND),VOLL; sperren	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sehr zeitkritisch ist das Schreiben eines 0-SLOT !							
;																				
; INP: OW_STATUS																
;																				
EXT_INT0:
	SBRC OW_STATUS,(7)					; springe, wenn Bit clear	
	sbi (OW_DDR),(OW_PIN_NR)			; AUF AUSGANG- WRITE 0-SLOT	
;-------------------------------------------------------------------------------
	push temp							; REGISTER sichern			
	in temp,SREG
	push temp
	push temp1
	push ZL
	push ZH
;-------------------------------------------------------------------------------
; WRITE 0-SLOT					
	SBRS OW_STATUS,(7)					; springe, wenn Bit set		
	rjmp OW_NO_TX_0SLOT
	clr OW_STATUS						; STATUS NULL		
	rcall WAIT_5us						; PAUSE ca.25s (0-SLOT) MASTER SAMPLES nach ca 9s		
	rcall WAIT_5us
	rcall WAIT_5us
	rjmp OW_AUSWERTUNG_ROM_COMAND		; --> Auswertung	
OW_NO_TX_0SLOT:
;-------------------------------------------------------------------------------
; WRITE 1-SLOT						
	SBRS OW_STATUS,(0)	; springe, wenn Bit set
	rjmp OW_NO_TX_1SLOT
	clr OW_STATUS						; STATUS NULL		
	rjmp OW_AUSWERTUNG_ROM_COMAND		; --> Auswertung	
OW_NO_TX_1SLOT:
; ------------------------------------------------------------------------------
; Bitzhler							
	SEC 							; set Carry				
	ROL OW_RX_BIT_ZAEHLER			; links ber Carry		
; ------------------------------------------------------------------------------
; SAMPLES(OW_RX_BYTE)				
	rcall wait_5us					; ca. 10s PAUSE				
	rcall wait_5us
	CLC								; Clear Carry					
	sbic (OW_PIN),(OW_PIN_NR)		; springe, wenn BIT(PIN) low	
	SEC 							; set Carry						
	ROR OW_RX_BYTE					; rechts ber Carry				
; ------------------------------------------------------------------------------
; BIT_ZAEHLER 						
	SBRS OW_RX_BIT_ZAEHLER,7		; Bit 7 set?			
	rjmp OW_RP_CHECK				; nein					
	clr OW_RX_BIT_ZAEHLER			; ja					
; ##############################################################################
; SAVE ROM_COMAND					
	LDS temp,(adr_OW_ROM_COMAND)
	tst temp						; ROM_COMAND NULL ?		
	brne OW_RX_ROM_COMAND_FERTIG	; nein					
	STS(adr_OW_ROM_COMAND),OW_RX_BYTE
	rjmp OW_AUSWERTUNG_ROM_COMAND	; --> Auswertung		
OW_RX_ROM_COMAND_FERTIG:
; ------------------------------------------------------------------------------
; SAVE FUNC_COMAND 					
	LDS temp,(adr_OW_FUNC_COMAND)
	tst temp						; FUNC_COMAND NULL ?	
	brne OW_RX_FUNC_COMAND_FERTIG	; nein					
	STS(adr_OW_FUNC_COMAND),OW_RX_BYTE
	rjmp OW_AUSWERTUNG_ROM_COMAND	; --> Auswertung		
OW_RX_FUNC_COMAND_FERTIG:
; ##############################################################################
; RX BYTES in das DATENFELD			
	ldi ZL,LOW (adr_OW_RX_DATA256)
	ldi ZH,HIGH(adr_OW_RX_DATA256)
	add ZL,OW_ZAEHLER	
	adc ZH,NULL
	ST Z,OW_RX_BYTE
	inc OW_ZAEHLER					; ZAEHLER+1		
	mov temp,OW_ZAEHLER
	andi temp,0b01111111			; begrenzen				
	mov OW_ZAEHLER,temp
; ##############################################################################
; ROM_COMAND						
OW_AUSWERTUNG_ROM_COMAND:
	LDS temp,(adr_OW_ROM_COMAND)	; ROM_COMAND		
	cpi temp,255					; gesperrt ?		
	brne OW_AUSWERTUNG_ROM_COMAND_RUN
	rjmp OW_AUSWERTUNG_FUNC_COMAND
OW_AUSWERTUNG_ROM_COMAND_RUN:
; ------------------------------------------------------------------------------
; ROM-READ							
	cpi temp,(OW_COMMAND_ROM_READ)	; ROM_READ	
	brne OW_NO_ROM_READ
	; Initialisieren				
	tst OW_ZAEHLER					; NULL ?	
	brne OW_ROM_READ_RUN			; nein		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_9_PORT),(LED_9_PIN_NR)	; 9 an		
	mov OW_ZAEHLER,EINS		
	rcall OW_KOPIE_ROM				; ROM-->SRAM
OW_ROM_READ_RUN:
	rjmp OW_TX_DATA
OW_NO_ROM_READ:
; ------------------------------------------------------------------------------
; SKIP-ROM							
	cpi temp,(OW_COMMAND_SKIP_ROM)
	brne OW_NO_SKIP_ROM
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_8_PORT),(LED_8_PIN_NR)	; 8 an		
	STS(adr_OW_ROM_COMAND),VOLL		; sperren	
	rjmp OW_AUSWERTUNG_FUNC_COMAND
OW_NO_SKIP_ROM:
; ------------------------------------------------------------------------------
; SEARCH-ROM						
	cpi temp,(OW_COMMAND_SEARCH_ROM); SEARCH_ROM
	brne OW_NO_SEARCH_ROM
	; Initialisieren				
	tst OW_ZAEHLER					; NULL ?	
	brne OW_SEARCH_ROM_RUN			; nein		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_7_PORT),(LED_7_PIN_NR)	; 7 an		
	mov OW_ZAEHLER,EINS	
	rcall OW_KOPIE_ROM				; ROM-->SRAM
	STS(adr_OW_SEARCH_COUNTER),NULL
OW_SEARCH_ROM_RUN:
	mov OW_ZAEHLER,EINS				; EINS !!!	
	LDS temp,(adr_OW_SEARCH_COUNTER); Counter	
	mov temp1,temp
	inc temp1						; Counter+1	
	STS(adr_OW_SEARCH_COUNTER),temp1
	cpi temp,0
	breq OW_SEARCH_VORBEREITUNG_A
	cpi temp,1
	breq OW_SEARCH_VORBEREITUNG_B
	cpi temp,2
	breq OW_SEARCH_VORBEREITUNG_RX
	rjmp OW_SEARCH_AUSWERTUNG
OW_SEARCH_VORBEREITUNG_A:			; Vorbereitung TX "A"	
	LDS temp,(adr_OW_TX_DATA256+0)
	LSR temp
	rjmp OW_TX_CARRY	
OW_SEARCH_VORBEREITUNG_B:			; Vorbereitung TX "B"	
	LDS temp,(adr_OW_TX_DATA256+0)
	LSR temp
	rjmp OW_TX_CARRY_INVERTIERT
OW_SEARCH_VORBEREITUNG_RX:			; Vorbereitung RX		
	mov OW_RX_BIT_ZAEHLER,VOLL		; damit das nchste BIT "durchkommt"
	rjmp OW_RP_CHECK
OW_SEARCH_AUSWERTUNG:				; AUSWERTUNG			
	LDS temp,(adr_OW_TX_DATA256+0)
	LSR temp						; C rollt raus			
	ROR OW_RX_BYTE					; C reinschieben		
	mov temp,OW_RX_BYTE
	andi temp,0b11000000
	cpi  temp,0b11000000			; vergleich A und RX-BYTES
	breq OW_SEARCH_AUSWERTUNG_OK
	cpi  temp,0b00000000
	breq OW_SEARCH_AUSWERTUNG_OK	; vergleich A und RX-BYTES
	rjmp OW_STATUS_SPERREN			; SPERREN	
OW_SEARCH_AUSWERTUNG_OK:
	STS(adr_OW_SEARCH_COUNTER),NULL
	rcall OW_TX_DATA_SCHIEBEN_C		; schieben	
	rjmp OW_SEARCH_ROM_RUN
OW_NO_SEARCH_ROM:
; ------------------------------------------------------------------------------
; MATCH-ROM							
	cpi temp,(OW_COMMAND_MATCH_ROM)	; MATCH_ROM ?
	breq OW_MATCH_ROM_w
	rjmp OW_NO_MATCH_ROM
OW_MATCH_ROM_w:
	STS(adr_OW_FUNC_COMAND),VOLL	; FUNC sperren	
	ldi temp,8						; alle 8 ID Bytes empfangen ?
	cp  temp,OW_ZAEHLER
	breq OW_MATCH_ROM_ww
	rjmp OW_RP_CHECK
OW_MATCH_ROM_ww:
	; Vergleich 				
	LDS temp ,(adr_OW_RX_DATA256+0)		; BYTE-0
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+0)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+1)		; BYTE-1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+1)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+2)		; BYTE-2
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+2)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+3)		; BYTE-3
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+3)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+4)		; BYTE-4
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+4)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+5)		; BYTE-5
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+5)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+6)		; BYTE-6
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+6)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	LDS temp ,(adr_OW_RX_DATA256+7)		; BYTE-7
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+7)
	cp temp,temp1
	brne OW_MATCH_ROM_FERIG				; nein	
	; MATCH-ROM OK					
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_6_PORT),(LED_6_PIN_NR)		; 6 an	
	STS(adr_OW_FUNC_COMAND),NULL		; FUNC-freigeben			
	STS(adr_OW_ROM_COMAND),VOLL			; COMAND-sperren			
	clr OW_ZAEHLER						; NULL, fr Initialisierung	
OW_MATCH_ROM_FERIG:
	rjmp OW_RP_CHECK
OW_NO_MATCH_ROM:
; ##############################################################################
; FUNC_COMAND						
OW_AUSWERTUNG_FUNC_COMAND:
	LDS temp,(adr_OW_FUNC_COMAND)
	cpi temp,0						; ignorieren ?		
	brne OW_AUSWERTUNG_FUNC_COMAND_w
	rjmp OW_RP_CHECK
OW_AUSWERTUNG_FUNC_COMAND_w:
	cpi temp,255					; gesperrt ?		
	brne OW_AUSWERTUNG_FUNC_COMAND_RUN
	rjmp OW_RP_CHECK
OW_AUSWERTUNG_FUNC_COMAND_RUN:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
; ------------------------------------------------------------------------------
; CONVERT_T							
	cpi temp,(OW_FUNCTION_CONVERT_T)
	brne OW_FUNCTION_NO_CONVERT_T
	cbi (LED_3_PORT),(LED_3_PIN_NR)			; 3 an	
	STS(adr_FREIGABE_MESSEN),EINS
	rjmp OW_STATUS_SPERREN	
OW_FUNCTION_NO_CONVERT_T:
; ------------------------------------------------------------------------------
; READ_SCRATCHPAD					
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD)
	brne OW_FUNCTION_NO_READ_SCRATCHPAD
	; Initialisieren				
	tst OW_ZAEHLER					; NULL ?
	brne OW_FUNCTION_READ_SCRATCHPAD_RUN
	cbi (LED_4_PORT),(LED_4_PIN_NR)	; 4 an	
	mov OW_ZAEHLER,EINS	
	rcall OW_KOPIE_SCRATCHPAD		; SCRATCHPAD-->SRAM	
OW_FUNCTION_READ_SCRATCHPAD_RUN:
	rjmp OW_TX_DATA
OW_FUNCTION_NO_READ_SCRATCHPAD:
; ------------------------------------------------------------------------------
; PRIVATE_DATA						
	cpi temp,(OW_FUNCTION_TX_PRIVATE_DATA)
	brne OW_FUNCTION_NO_PRIVATE_DATA
	rjmp OW_RP_CHECK
OW_FUNCTION_NO_PRIVATE_DATA:
; ------------------------------------------------------------------------------
; RECALL_EE							
	cpi temp,(OW_FUNCTION_RECALL_EE)
	brne OW_FUNCTION_NO_RECALL_EE
	rjmp OW_RP_CHECK
OW_FUNCTION_NO_RECALL_EE:
; ------------------------------------------------------------------------------
; UNBEKANNT							
OW_FUNCTION_UNBEKANNT:
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	rjmp OW_STATUS_SPERREN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RESET-PRESENCE-CHECK															
OW_RP_CHECK:
	cbi (OW_DDR), (OW_PIN_NR)			; AUF EINGANG		
	clr ZL
	clr ZH
OW_RP_s:
	sbic (OW_PIN),(OW_PIN_NR)	; springe, wenn BIT(PIN) low
	rjmp OW_RESET_PRESENCE_AUSWERTUNG
	adiw ZL,1					; ZHLER				
	brcc OW_RP_s				; OW_RP_UEBERLAUF ?		
; ------------------------------------------------------------------------------
OW_RP_UEBERLAUF:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	rjmp OW_RP_UEBERLAUF
; ------------------------------------------------------------------------------
OW_RESET_PRESENCE_AUSWERTUNG:
	cpi ZH,HIGH(300)			; vergleich (HIGH)		
	brlo OW_FERTIG
	breq OW_RESET_PRESENCE_L
	brsh OW_RP_ERKANNT
OW_RESET_PRESENCE_L:
	cpi ZL,LOW(300)				; vergleich (LOW)		
	brlo OW_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_RP_ERKANNT:
	STS(adr_OW_ZAEHLER_RP_L),ZL	; speichern (Wartungszwecke)
	STS(adr_OW_ZAEHLER_RP_H),ZH
	clr OW_STATUS
	clr OW_RX_BIT_ZAEHLER
	clr OW_ZAEHLER
	STS(adr_OW_ROM_COMAND),NULL
	STS(adr_OW_FUNC_COMAND),NULL
	STS(adr_OW_SEARCH_COUNTER),NULL
	rcall LED_BALKEN_AUS
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)	; GELB aus	
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)	; ROT  aus	
; ------------------------------------------------------------------------------
	sbi (OW_DDR), (OW_PIN_NR)	; AUF Ausgang	
	rcall WAIT_100us	
	rcall WAIT_100us	
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
; ------------------------------------------------------------------------------
OW_FERTIG:
	pop ZH									; REGISTER wieder herstellen		
	pop ZL	
	pop temp1
	pop	temp
	OUT SREG, temp							; SREG	
	pop temp
	out GIFR,VOLL							; eventuelle Pegelwechsel ignorieren
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1-wire-STATUS	sperren !														
OW_STATUS_SPERREN:
	STS(adr_OW_ROM_COMAND) ,VOLL; sperren	
	STS(adr_OW_FUNC_COMAND),VOLL; sperren	
	rjmp OW_RP_CHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1-wire-TX_0SLOT 																
OW_STATUS_TX_0SLOT:
	mov OW_STATUS,VOLL
	rjmp OW_RP_CHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1-wire-TX_0SLOT 																
OW_STATUS_TX_1SLOT:
	mov OW_STATUS,EINS
	rjmp OW_RP_CHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_TX_CARRY:
	brcs OW_STATUS_TX_1SLOT
	rjmp OW_STATUS_TX_0SLOT
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_TX_CARRY_INVERTIERT:
	brcs OW_STATUS_TX_0SLOT
	rjmp OW_STATUS_TX_1SLOT
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_TX_DATA:
	rcall OW_TX_DATA_SCHIEBEN_C
	brcs OW_STATUS_TX_1SLOT
	rjmp OW_STATUS_TX_0SLOT
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_TX_DATA_SCHIEBEN_C:
	SEC								; CARRY=1	
	LDS temp,(adr_OW_TX_DATA256+8)	; Bytes-8
	ROR temp
	STS(adr_OW_TX_DATA256+8),temp
	LDS temp,(adr_OW_TX_DATA256+7)	; Bytes-7
	ROR temp
	STS(adr_OW_TX_DATA256+7),temp
	LDS temp,(adr_OW_TX_DATA256+6)	; Bytes-6
	ROR temp
	STS(adr_OW_TX_DATA256+6),temp
	LDS temp,(adr_OW_TX_DATA256+5)	; Bytes-5
	ROR temp
	STS(adr_OW_TX_DATA256+5),temp
	LDS temp,(adr_OW_TX_DATA256+4)	; Bytes-4
	ROR temp
	STS(adr_OW_TX_DATA256+4),temp
	LDS temp,(adr_OW_TX_DATA256+3)	; Bytes-3
	ROR temp
	STS(adr_OW_TX_DATA256+3),temp
	LDS temp,(adr_OW_TX_DATA256+2)	; Bytes-2
	ROR temp
	STS(adr_OW_TX_DATA256+2),temp
	LDS temp,(adr_OW_TX_DATA256+1)	; Bytes-1
	ROR temp
	STS(adr_OW_TX_DATA256+1),temp
	LDS temp,(adr_OW_TX_DATA256+0)	; Bytes-0
	ROR temp
	STS(adr_OW_TX_DATA256+0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_KOPIE_ROM:
	LDS temp,(adr_OW_ROM_ID_BEREICH8+0)
	STS (adr_OW_TX_DATA256+0),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+1)
	STS (adr_OW_TX_DATA256+1),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+2)
	STS (adr_OW_TX_DATA256+2),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+3)
	STS (adr_OW_TX_DATA256+3),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+4)
	STS (adr_OW_TX_DATA256+4),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+5)
	STS (adr_OW_TX_DATA256+5),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+6)
	STS (adr_OW_TX_DATA256+6),temp
	LDS temp,(adr_OW_ROM_ID_BEREICH8+7)
	STS (adr_OW_TX_DATA256+7),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_KOPIE_SCRATCHPAD:
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+0)
	STS (adr_OW_TX_DATA256+0),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+1)
	STS (adr_OW_TX_DATA256+1),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+2)
	STS (adr_OW_TX_DATA256+2),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+3)
	STS (adr_OW_TX_DATA256+3),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+4)
	STS (adr_OW_TX_DATA256+4),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+5)
	STS (adr_OW_TX_DATA256+5),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+6)
	STS (adr_OW_TX_DATA256+6),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+7)
	STS (adr_OW_TX_DATA256+7),temp
	LDS temp,(adr_OW_SCRATCHPAD_BEREICH9+8)
	STS (adr_OW_TX_DATA256+8),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CRC Berechnung bernommen und abgendert von: http://s-huehn.de				
; CRC-Berechnung Application Note 27 von Dallas/Maxim							
;																				
; CRC-ROM																		
; INP: SRAM																		
;																				
ONE_WIRE_ROM_CRC7:
	push XL          ; auf dem Stack sichern            
	push XH
	push r16
	push r17
	push r18
	push r19
	push r20
	push r21
ONE_WIRE_ROM_CRC7_RUN:
	; INITIALISIERUNG
 	ldi XL,low (adr_OW_ROM_ID_BEREICH8+0) ;Zeiger 				
    ldi XH,high(adr_OW_ROM_ID_BEREICH8+0) 
    ldi     r19, 7                          ;7 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            ;CRC-Startwert = 0 setzen
ONE_WIRE_CRC7_100: 
	ld      r18, x+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
ONE_WIRE_CRC7_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    ONE_WIRE_CRC7_300                          ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
ONE_WIRE_CRC7_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    ONE_WIRE_CRC7_200               ;nein -> Schleife
    dec     r19                             ;alle Bytes bearbeitet?
    brne    ONE_WIRE_CRC7_100               ;nein -> Schleife
;-------------------------------------------------------------------------------
	LDS temp,(adr_OW_ROM_ID_BEREICH8+7)
	; Korrektur
	STS(adr_OW_ROM_ID_BEREICH8+7),R17
	cp temp,r17
	brne ONE_WIRE_CRC7_ERROR
	SEC										; CARRY=1	
	rjmp ONE_WIRE_CRC7_FERTIG
;-------------------------------------------------------------------------------
ONE_WIRE_CRC7_ERROR:
	; nochmal prfen !			
	rjmp ONE_WIRE_ROM_CRC7_RUN
;-------------------------------------------------------------------------------
ONE_WIRE_CRC7_FERTIG:
	pop r21      							; wiederherstellen                	
	pop r20
	pop r19
	pop r18
	pop r17
	pop r16
	pop XH
	pop XL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
SCRATCHPAD_CRC8:
 	ldi ZL,low (adr_OW_SCRATCHPAD_BEREICH9+0) 	; Z-Zeiger 					
    ldi ZH,high(adr_OW_SCRATCHPAD_BEREICH9+0) 
    ldi     r19, 8                          ;8 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            	;CRC-Startwert = 0 setzen
SCRATCHPAD_CRC8_100: 
	LD      r18, Z+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
SCRATCHPAD_CRC8_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    SCRATCHPAD_CRC8_300             ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
SCRATCHPAD_CRC8_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    SCRATCHPAD_CRC8_200        		;nein -> Schleife		
    dec     r19                             ;alle Bytes bearbeitet?	
    brne    SCRATCHPAD_CRC8_100    		 	;nein -> Schleife		
;-------------------------------------------------------------------------------
	; Ergebnis in R17	
	STS(adr_OW_SCRATCHPAD_BEREICH9+8),R17
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
